import java.util.*;
public class Sort {
  public static void main(String[] args) {
    Scanner input = new Scanner(System.in);
    List<Integer> L = new ArrayList<Integer>();
    System.out.print("Input number of ints to be sorted: ");
    int n = input.nextInt();
    for (int i=0; i<n; i++) {
      System.out.print("Input next int: ");
      L.add(i, new Integer(input.nextInt()));
    }
    sort(L);
    for (int i=0; i<n; i++) System.out.println(L.get(i));
  }
  public static <E extends Comparable<E>> void sort(List<E> L) {
    if (L.size() <= 1) return; // L is already sorted in this case
    int i, j, n=L.size();
    for (i=1; i<n; i++) {
      E curr = L.get(i);
      j = i-1;
     while ((j>= 0) && (curr.compareTo(L.get(j)) < 0)) {
       L.set(j+1, L.get(j)); // move index-j element to index j+1
       j=j-1;
     } // end while
     L.set(j+1,curr);
    } // end for
  }
}
    

