import java.util.*;
public class Sort {
  public static void main(String[] args) {
    Scanner input = new Scanner(System.in);
    PositionalList<Integer> L = new LinkedPositionalList<Integer>();
    System.out.print("Input number of ints to be sorted: ");
    int n = input.nextInt();
    try {
    for (int i=0; i<n; i++) {
      System.out.print("Input next int: ");
      L.addFirst(new Integer(input.nextInt()));
    }
    sort(L);
    Position<Integer> p = L.first();
    while (p != L.last()) {
      System.out.println(p.getElement().intValue());
      p = L.after(p);
    }
    System.out.println(p.getElement().intValue());
    } 
    catch (InvalidPositionException e)
	{System.out.println("Errore!");}
    catch (EmptyListException e)
	{System.out.println("Errore!");}
    catch (BoundaryViolationException e)
	{System.out.println("Errore!");}
  }
  public static <E extends Comparable<E>> void sort(PositionalList<E> L)     
    throws InvalidPositionException, EmptyListException, 
           BoundaryViolationException {
    if (L.size() <= 1) return; // L is already sorted in this case
    Position<E> pivot = L.after(L.first());     // pivot node
    Position<E> ins = L.first();        // insertion point
    while (true) {
      E x1 = pivot.getElement(), x2 = ins.getElement() ;
      while ((x1.compareTo(x2) < 0)) {
        L.set(ins, x1);
        L.set(L.after(ins), x2);
        if (ins == L.first()) break;
        ins = L.before(ins);
        x2 = ins.getElement();  
      }
      if (pivot == L.last()) return;
      else {
        ins = pivot;
        pivot = L.after(pivot);
      }
    }
  }
}
    

