import java.util.Scanner;

public class Fibonacci {
     public static void main(String[] args) {
    	Scanner input = new Scanner(System.in);
	System.out.print("Which Fibonacci number do you want?");
    	int n = input.nextInt();	

	//compute F(n) with iterFibonacci and measure running time
    	System.out.println("\nLet's start the iterative algorithm!");
	long time1 = System.currentTimeMillis();
    	long f = iterFibonacci(n);
    	long time2 = System.currentTimeMillis();
    	System.out.println("F(n)="+f);
    	System.out.println("Time of iterFibonacci="+(time2-time1));

	//compute F(n) with recFibonacci and measure running time
	System.out.println("\nLet's start the recursive algorithm!");
	time1 = System.currentTimeMillis();
	f = recFibonacci(n);
	time2 = System.currentTimeMillis();
	System.out.println("F(n)="+f);
	System.out.println("Time of recFibonacci="+(time2-time1));
    }

   /*Iterative algorithm*/
   public static long iterFibonacci(int n){
    	if(n<=1) return n;
    	long x=0;    long y=1;     long tmp;
    	for(int i=2; i<=n; i++){
    		tmp = x;      x = y;     y = tmp+x;
		//At the end of the ith iteration, x=F(i-1) and y=F(i)
    	}
    	return y;
   }

  /*Recursive algorithm*/
  public static long recFibonacci(int n){
	if ((n == 0) || (n == 1)) return n; //base cases
	return recFibonacci(n-1)+recFibonacci(n-2);
  }
} // end of class Fibonacci

